/*
 * Copyright 2005 - 2006 Yahoo! Inc. All rights reserved.
 */
function yahooLoadDialog() {
	try {		
		if(typeof(document.location.hash) == 'undefined' && document.location.hash.length < 2){
			yahooDialogError();
			return;
		}
		var id = document.location.hash;
		id = id.substring(1);
		var url = id;
		yahooToolbarFeed = Components.classes["@yahoo.com/feed/processor;1"].getService(Components.interfaces.nsIYahooFeedProcessor);
		var dlg = yahooToolbarFeed.params.get("xuldlg_m");
		if(dlg && (dlg = dlg.getNodeById("yahoo-toolbar-xuldlg-"+ id) ) != null){
			dlg.formatFunction();
			var url = yahooBuildEventURL(dlg.funcUrl.split(","), null);
			if(url == null){
				url = id;
			}
		}
		var parent	= document.firstChild;
		var dom 	= yahooGetRemoteXmlDom(url);
		if(dom.firstChild.localName == 'parsererror'){
			yahooDialogError();
			return;
		} 
		parent.removeChild(document.getElementById("dialog-loading"));
		var elements = dom.documentElement.childNodes;
		for(var i = 0; i < elements.length; i++) {
			yahooBuildDialogDom(parent, elements[i]);
		}
		var attrs = dom.documentElement.attributes;
		var onload = null;
		for(var i = 0; i < attrs.length; i++) {
			if(attrs[i].nodeName == 'onload') {
				onload = attrs[i].nodeValue;
			} 
			else {
				parent.setAttribute(attrs[i].nodeName, attrs[i].nodeValue);
			}
		}
		if(onload != null) {
			try {
				eval(onload);
			} catch(e) {
			}
		}
	} catch(e) {
		yahooDialogError();
	}
}
function yahooBuildDialogDom(parent, child) {
	var node = null;
	try{
		var src = "";
		if(child.nodeName == "script" && (src = child.attributes.getNamedItem("src")) != null && src.nodeValue != ""){
			script = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
			script.loadSubScript(src.nodeValue);
		}
		else if(child.nodeType == child.ELEMENT_NODE) {
			node = document.createElement(child.nodeName);
			for(var i = 0; i < child.attributes.length; i++) {
				node.setAttribute(child.attributes[i].nodeName, child.attributes[i].nodeValue);
			}
			parent.appendChild(node);
			for(var i = 0; i < child.childNodes.length; i++) {
				yahooBuildDialogDom(node, child.childNodes[i]);
			}
		} 
		else if(child.nodeType == child.TEXT_NODE) {		
			node = document.createTextNode(child.nodeValue);
			parent.appendChild(node);
		}
	} catch(e){ 
	}
	return node;
}
function yahooDialogError(){
	document.getElementById("dialog-error").setAttribute("hidden", "false");
}
