/*
 * Copyright 2005 - 2006 Yahoo! Inc. All rights reserved.
 */
function yahooFetchURLSync(url) {
	var iosvc 	= Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var channel = iosvc.newChannel(url, 0, null);
	var stream 	= channel.open();
	var fh 		= Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
	fh.init(stream);
	var size = 0;
	var data = "";
	while(size = stream.available()) {
		data += fh.read(size);
	}
	fh.close();
	yahooWriteCacheFile('syncreq.txt', data);
	if(channel instanceof Components.interfaces.nsIHttpChannel && channel.responseStatus != 200) {
		yahooFeedIsLoading = false;
		throw 'feed server returned a '+channel.responseStatus+' error';
	}
	return data;
}
function yahooGetRemoteXmlDom(url){
	var data = "";
	var dom = null;
	try{
		var cacheFile = null;
		var chromeFile = url +".xul";
		var urlParts = url.match(/\/x[um]l\/(..)\/(.*?)-([0-9]*)\.(x[um]l)/);
		if(urlParts) {
			cacheFile = urlParts[1] +"."+ urlParts[2] +"."+ urlParts[3];
			chromeFile = urlParts[2] +"."+ urlParts[4];
		}
		if(cacheFile != null){
			data = yahooReadCacheFile(cacheFile);
		}
		if(url != "" && (data == null || data.length <= 0)){
			try{
				data = yahooFetchURLSync(url);
				if(cacheFile != null && data.length > 0){
					try{
						yahooWriteCacheFile(cacheFile, data)
					}catch(e){ 
					}
				}
			}catch(e){ 
			}
		} 
		if(data == null || data.length <= 0){
			data = yahooFetchURLSync("chrome://ytoolbar/content/cache/"+ chromeFile);
			if(data.length <= 0){
				throw "Unable to download feed"
			}
		}
		try{
			yahooUnicodeConverter.charset = 'utf-8'; 	 
			data = yahooUnicodeConverter.ConvertToUnicode(data);
		} catch(e){ }
		dom = (new DOMParser()).parseFromString(data, 'text/xml');
	}catch(e){
		throw "(yahooGetRemoteXmlDom)\n "+ e;
	}
	return dom;
}
