/*
 * Copyright 2005 - 2006 Yahoo! Inc. All rights reserved.
 */
var gYahooButtonPopup = null
function yahooDestroyNode(node) {
	if(node == null) return;
	while(node.hasChildNodes()) {
		node.removeChild(node.firstChild);
	}
}
function yahooBuildToolbar() {
	try{
		if(yahooToolbarFeed.domBuilder.toolbar == null
				|| yahooToolbarFeed.domBuilder.toolbar.childNodes.length == 0 
				|| yahooToolbarFeed.domBuilder.toolbar.firstChild.childNodes.length == 0){
			if(yahooToolbarFeed.loadedType != yahooToolbarFeed.CACHE_LOADED){
				yahooToolbarFeed.loadCachedFeed();
			}
			return;
		}
		if(yahooBuildingToolbar == true){
			yahooToolbarBuildQueue = true;
			return;
		}	
		yahooBuildingToolbar = true;
		var toolbar = document.getElementById('yahoo-toolbar');
		var menubar = document.getElementById('yahoo-menubar-item');
		var tcontext = document.getElementById("yahoo-toolbar-context");
		var pcontext = document.getElementById("yahoo-toolbar-rmc_m");
		var moreMenu = document.getElementById('yahoo-toolbar-more-menu');
		if(typeof(fade) == 'undefined'){
			fade = false;
		}
		yahooDestroyNode(toolbar);
		yahooDestroyNode(menubar);
		yahooDestroyNode(tcontext);
		yahooDestroyNode(pcontext);
		yahooBookmarkMenu = null;
		toolbar.appendChild(yahooToolbarFeed.domBuilder.toolbar.cloneNode(true));
		menubar.appendChild(yahooToolbarFeed.domBuilder.menubar.cloneNode(true));
		if(yahooGetPref('yahoo.options.menubar') == false || yahooToolbarFeed.domBuilder.menubar.childNodes.length == 0){
			menubar.parentNode.setAttribute("hidden", true);
		}
		else{
			menubar.parentNode.setAttribute("hidden", false);
		}
		menubar.appendChild(yahooToolbarFeed.domBuilder.menubarExtra.cloneNode(true));
		if(yahooToolbarFeed.domBuilder.toolar_context.childNodes.length > 0){
			var context = yahooToolbarFeed.domBuilder.toolar_context.firstChild.firstChild;
			for(var i = 0; i < context.childNodes.length; i++){
				tcontext.appendChild(context.childNodes[i].cloneNode(true));
			}
			context = null;
		}
		if(yahooToolbarFeed.domBuilder.page_context.childNodes.length > 0){
			var context = yahooToolbarFeed.domBuilder.page_context.firstChild.firstChild;
			for(var i = 0; i < context.childNodes.length; i++){
				pcontext.appendChild(context.childNodes[i].cloneNode(true));
			}
			var context = yahooToolbarFeed.domBuilder.page_context.firstChild;
			for(var i = 0; i < context.attributes.length; i++){
				pcontext.parentNode.setAttribute(context.attributes[i].name, context.attributes[i].value);
			}
			pcontext.parentNode.hidden = false;
			context = null;
		}
		else{
			pcontext.parentNode.hidden = true;
		}
		yahooAddAlerts();
		yahooAddFlexBox(toolbar);
		yahooBuildToolbarPost();
		toolbar = null;
		menubar = null;
		tcontext = null;
		pcontext = null;
		moreMenu = null;
	}catch(e){
	}
	return true;
}
function yahooBuildToolbarPost(){
	var btn;
	var toolbar = document.getElementById('yahoo-toolbar');
	yahooBuildHistory();
	yahooRSSInit();
	yahooCheckForRSS(null);
	if(yahooGetPref("yahoo.options.antispy") == false){
		if( (btn = document.getElementById("yahoo-toolbar-psr1_m")) != null){
			btn.hidden = true;
		}
		if( (btn = document.getElementById("menu_yahoo-toolbar-psr1_m")) != null){
			btn.hidden = true;
		}
	}
	btn = document.getElementById("yahoo-toolbar-cm-sio");
	if(btn != null){
		btn.setAttribute("checked", yahooParamNOTEXT.toLowerCase());
	}	
	yahooOptionsApply();
	var myMenus = [ document.getElementById('yahoo-toolbar-my-rssa'), document.getElementById('menu_yahoo-toolbar-my-rssa') ];
	for(var i = 0; i < myMenus.length; i++){
		if(myMenus[i] != null) {
			myMenus[i].setAttribute("type", "checkbox");
			if(yahooGetPref('yahoo.addtomy') == true) {
				myMenus[i].setAttribute('checked', 'true');
			} 
			else {
				myMenus[i].setAttribute('checked', 'false');
			}
		}
	}
	yahooToolbarOverflowDelay();
	if(yahooToolbarBuildQueue == true){
		setTimeout("yahooBuildToolbar()", 1000);
	}
	yahooBuildingToolbar = false;
	var time = (new Date()).getTime();
	yahooProfileTime -= .001;
	yahooProfileTime = time;
}
function yahooDumpXUL(node, depth) {
	var indent = '';
	for(var i = 0; i < depth; i++) {
		indent += '\t';
	}
	if(node.nodeType == node.TEXT_ELEMENT) {
		return indent+node.nodeValue;
	}
	var xul = indent + '<'+node.nodeName;
	var attrIndent = indent;
	for(var i = 0; i < node.nodeName.length+2; i++) {
		attrIndent += ' ';
	}
	for(var i = 0; i < node.attributes.length; i++) {
		if(i == 0) {
			xul += ' '+node.attributes[i].nodeName+'="'+node.attributes[i].nodeValue+'"';
		} else {
			xul += attrIndent+node.attributes[i].nodeName+'="'+node.attributes[i].nodeValue+'"';
		}
		if(i < node.attributes.length - 1) {
			xul += '\n';
		}
	}
	if(node.childNodes.length == 0) {
		xul += '/>\n';
	} else {
		xul += '>\n';
		for(var i = 0; i < node.childNodes.length; i++) {
			xul += yahooDumpXUL(node.childNodes[i], depth+1);
		}
		xul += indent+'</'+node.nodeName+'>\n';
	}
	return xul;
}
function yahooAddImportBookmarks(toolbar) {
	var menu = toolbar.ownerDocument.getElementById("yahoo-toolbar-Bookmarks-1");
	if(menu != null) {
		try {
		var menuitem = toolbar.ownerDocument.createElement('menuitem');
		menuitem.setAttribute('label', 'Import Firefox Bookmarks');
		menuitem.setAttribute('tooltiptext', 'Import your Firefox Bookmarks into My Yahoo!');
		menuitem.setAttribute('oncommand', 'yahooImportBookmarksHTML();');
		menu.firstChild.insertBefore(menuitem, menu.firstChild.getElementsByTagName('menuseparator')[0]);
		} catch(e) {
		}
	} else {
	}
}
function yahooAddFlexBox(toolbar) {
	var flexBox = document.createElement('hbox');
	flexBox.id = 'yahoo-toolbar-flexbox';
	flexBox.setAttribute('flex', 10);
	toolbar.appendChild(flexBox);
}
function yahooAddAlerts(){
	try{
		var btns = document.getElementById("yahoo-toolbar-reqbtns");
		var alerts = yahooToolbarFeed.domBuilder.alerts;
		if(btns == null || alerts == null || alerts.childNodes.length == 0){
			return;
		}
		var alert, dup;
		for(var i = 0; i < alerts.childNodes.length; i++){
			alert = alerts.childNodes[i].cloneNode(true);
			if(alert.id && (dup = document.getElementById(alert.id)) != null && dup.parentNode == btns){
				btns.removeChild(dup);
			}
			btns.insertBefore(alert, btns.lastChild);
		}
		yahooToolbarOverflowDelay();
	}catch(e){
	}
}
function yahooTransitionToolbar(dir, btns){
	var speed = 50;
	var deck = document.getElementById("yahoo-toolbar-deck");
	if(btns != null){
		btns.style.opacity = 0.111;
		deck.appendChild(btns);
		if(deck.childNodes.length > 1){
			deck.firstChild.style.opacity = 0.999;
			deck.firstChild.id = null;
		}
		else{
			dir = 1;
		}
	}
	var opacity = parseFloat(deck.firstChild.style.opacity);
	if(dir < 0){
		deck.firstChild.style.opacity =  opacity - .111;
		if((opacity - .1) > 0.111){
			setTimeout("yahooTransitionToolbar(-1)", speed);
		}
		else{
			yahooDestroyNode(deck.firstChild);
			deck.removeChild(deck.firstChild);
			yahooTransitionToolbar(1);
		}
	}
	else{
		if(opacity < 0.999){
			deck.firstChild.style.opacity =  opacity + .111;
			setTimeout("yahooTransitionToolbar(1)", speed);
		}
		else{	
			deck.firstChild.id = "yahoo-toolbar-btns";
			yahooBuildToolbarPost();
		}
	}
}
function yahooAddToHistory(value) {
	try{
		if(value.search(/[^\s]/) < 0){
			return;
		}
		value = escape(value);
		var queries = yahooSearchHistory.childNodes;
		for(i = queries.length - 1; i >= 0; i--) {
			if(queries[i].childNodes[0].data == value) {
				yahooSearchHistory.removeChild(queries[i]);
			}
		}
		var query = yahooSearchHistory.ownerDocument.createElement("query");
		query.appendChild(yahooSearchHistory.ownerDocument.createTextNode(value));
		if(yahooSearchHistory.firstChild){
			yahooSearchHistory.insertBefore(query, yahooSearchHistory.firstChild);
		}
		else{
			yahooSearchHistory.appendChild(query);
		}
		yahooSaveSearchHistory();
	}catch(e){
	}
} 
function yahooInitSearchBox() {
	try{
		var queries = yahooSearchHistory.childNodes;
		var search = document.getElementById("yahooToolbarEditBox");
		var history = document.getElementById("yahooToolbarEditBox-history");
		if(search != null){
			if(yahooGetPref('yahoo.toolbar.searchbox.width') != null){
				search.setAttribute('width', yahooGetPref('yahoo.toolbar.searchbox.width'));
			}
			else{
				search.setAttribute('width', '200');
			}
		}
		if(history != null){
			while(history.firstChild){
				history.removeChild(history.firstChild);
			}
			if(queries.length == 0){
				history.appendChild(document.createElement('menuitem')).label = "";
			}
			var menuitem, query, added = 0;
			for(var i = 0; i < queries.length; i++) {
				query = queries[i].childNodes[0].data;
				if(query.search(/[^\s]/) > -1){
					menuitem = document.createElement('menuitem');
					menuitem.setAttribute('label', query);
					menuitem.setAttribute('value', query);
					menuitem.setAttribute('yfunc', search.getAttribute("yfunc"));
					menuitem.setAttribute('yevent', search.getAttribute("yevent"));
					history.appendChild(menuitem);
					added++;
				}
				if(added >= 30){
					break;
				}
			}
		}
		yahooSetSearchboxSize();
	} catch(e){
	}
}
function yahooFormatStyles(node){
	var styles = node.getAttribute("ystyles").split(",");
	var arr = {};
	for(var i = 0; i < styles.length; i++){
		if(styles[i].search(/[^\s]/) > -1){
			arr[styles[i]] = 1;
		}
	}
	return arr;
}
function yahooSizePopup(list){
	try{
		list.popup.setAttribute("minwidth", list.boxObject.width);
	} catch(e){
	}
}
function yahooToolbarOverflowDelay() {
	if(yahooToolbarOverflowTimer) {
		return false;
	}
	yahooToolbarOverflowTimer++;
	setTimeout(yahooToolbarOverflow, 500);
}
function yahooSplitterResize(){
	try{
		var search = document.getElementById("yahooToolbarEditBox");
		if(search == null){
			return;
		}
		yahooSetPref('yahoo.toolbar.searchbox.width', search.boxObject.width);
		search.size = 4;
		search.userwidth = search.boxObject.width;
		search.style.minWidth = "";
		yahooToolbarOverflowDelay();
	}catch(e){
	 }
}
function yahooSetSearchboxSize(){
	try{	
		var toolbar = document.getElementById('yahoo-toolbar');
		var reqBtns = document.getElementById('yahoo-toolbar-reqbtns');
		var searchBox = document.getElementById('yahooToolbarEditBox');	
		var width = (reqBtns.boxObject.width - searchBox.boxObject.width) + 35
		width = toolbar.boxObject.width - width;
		if(width < 120){
			width = 120;
		}
		searchBox.setAttribute("maxwidth", width);
		searchBox.style.width = searchBox.width +"px";
		searchBox.width = "";
	}catch(e){
	}
}
function yahooTrackButtonPopup(button){
	var popup = button.firstChild;
	if(popup != null && popup.tagName == "menupopup"){
		gYahooButtonPopup = popup;
	}
	else{
		gYahooButtonPopup = null;
	}
}
function yahooCloseLastButonPopup(button){
	try{
		if(gYahooButtonPopup == null){
			return;
		}
		var popup = button.firstChild;
		if(popup == null || popup.parentNode.id != gYahooButtonPopup.parentNode.id){
			gYahooButtonPopup.parentNode.open = false;
			gYahooButtonPopup = null;
		}
	}catch(e){
	}
}
function yahooToolbarElongate(moreMenu) {
	try{
		var toolbar = document.getElementById('yahoo-toolbar-btns');
		var flexBox = document.getElementById('yahoo-toolbar-flexbox');
		if(toolbar == null){
			return;
		}
		while(flexBox.boxObject.width > 10) {
			var button;
			var firstMenuItem = moreMenu.firstChild.firstChild;
			if(firstMenuItem == null) {
				moreMenu.removeChild(moreMenu.firstChild);
				moreMenu.parentNode.removeChild(moreMenu);
				return true;
			}
			if(firstMenuItem.tagName == 'menuseparator') {
				button = document.createElement('toolbarseparator');
				toolbar.appendChild(button);
				moreMenu.firstChild.removeChild(firstMenuItem);
				continue;
			}
			else{
				button = firstMenuItem.cloneNode(true);
				button.setAttribute("class", firstMenuItem.getAttribute("class"));	
			}
			toolbar.appendChild(button);
			moreMenu.firstChild.removeChild(firstMenuItem);
		}
	} catch(e){
	}
	return true;
}
function yahooToolbarShorten() {
	try{
		var toolbar = document.getElementById('yahoo-toolbar');
		var flexBox = document.getElementById('yahoo-toolbar-flexbox');
		var moreMenu = document.getElementById('yahoo-toolbar-more-menu');
		if(moreMenu == null) {
			moreMenu = document.createElement('toolbarbutton');
			moreMenu.setAttribute('type', 'menu');
			moreMenu.setAttribute('width', '20');
			moreMenu.setAttribute('image', "chrome://ytoolbar/skin/chevron.gif");
			toolbar.appendChild(moreMenu);
			moreMenu.id = 'yahoo-toolbar-more-menu';
			var popup = document.createElement('menupopup');
			moreMenu.appendChild(popup);
		}
		var windowWidth = toolbar.boxObject.width;
		var moreMenuBox = moreMenu.ownerDocument.getBoxObjectFor(moreMenu);
		var spaceNeeded = moreMenuBox.x + moreMenuBox.width - windowWidth;
		toolbar = document.getElementById('yahoo-toolbar-btns');
		if(spaceNeeded <= 1 && moreMenu.firstChild.childNodes.length == 0) {;
			moreMenu.parentNode.removeChild(moreMenu);
			return true;
		}
		while(spaceNeeded > 1) {
			var lastChild = toolbar.lastChild;
			if(lastChild == null || toolbar.childNodes.length == 0) {
				break;
			} 
			spaceNeeded -= lastChild.boxObject.width;
			var firstMenuItem = moreMenu.firstChild.firstChild;
			var newMenuItem;
			if(lastChild.tagName == 'toolbarseparator') {
				newMenuItem = toolbar.ownerDocument.createElement('menuseparator');
			} 
			else{
				newMenuItem = lastChild.cloneNode(true);
				newMenuItem.setAttribute("class", lastChild.getAttribute("class"));
			}
			if(firstMenuItem != null) {
				moreMenu.firstChild.insertBefore(newMenuItem, firstMenuItem);
			} 
			else {
				moreMenu.firstChild.appendChild(newMenuItem);
			}
			toolbar.removeChild(lastChild);
		}
	} catch(e){
	}
	return true;
}
function yahooToolbarOverflow() {
	yahooToolbarOverflowTimer--;
	if(yahooToolbarOverflowRunning || yahooToolbarOverflowTimer > 0) {
		return false;
	}
	try {
		yahooToolbarOverflowRunning = true;
		var toolbar = window.top.document.getElementById('yahoo-toolbar');
		var toolbarBtns = window.top.document.getElementById('yahoo-toolbar-btns');
		var flexBox = toolbar.ownerDocument.getElementById('yahoo-toolbar-flexbox');
		var moreMenu = toolbar.ownerDocument.getElementById('yahoo-toolbar-more-menu');
		yahooSetSearchboxSize();
		if(moreMenu != null && moreMenu.firstChild != null) {
			yahooToolbarElongate(moreMenu);
			setTimeout(yahooToolbarShorten, 250);
		}
		else if(flexBox != null && flexBox.boxObject != null && flexBox.boxObject.width <= 0) {
			yahooToolbarShorten();
		} 
		else {
			yahooToolbarOverflowRunning = false;
			return true;
		}
		yahooToolbarOverflowRunning = false;
		return true;
	} catch(e) {
		yahooToolbarOverflowRunning = false;
	}
}
