/*
 * Copyright 2005 - 2006 Yahoo! Inc. All rights reserved.
 */
function yahooHitTrackingUrl(template, spaceid, noLocale){
	var url;
	try{
		noLocale = noLocale || false;
		if(template == null){
			template = "/firefox/guest/__SPACEID__/*__URL__";
		}
		if(template.indexOf("__SPACEID__") > -1 && (spaceid == null || spaceid == "" || spaceid == "-1")){
			return;
		}
		url = template;
		var channel = yahooGetPref('yahoo.installer.dc') || "nodc";
		var numdownloads = yahooGetPref('yahoo.installer.nd') || 0;
		var lang = yahooGetPref('yahoo.installer.language');
		var server = yahooGetFeedVariable("RDSRV");
		var param;
		if(yahooToolbarFeed != null && yahooToolbarFeed.params != null &&
				(param = yahooToolbarFeed.params.get("lang")) != null){
			lang = param.func;
		}
		if(server == null){
			server = "rd.companion.yahoo.com";
		}
		if(lang != "us" && noLocale == false){
			server = lang +"."+ server;
		}
		url = url.replace("companion", "firefox");
		url = url.replace(/__SPACEID__/g, spaceid);
		url = url.replace(/__CHANNEL__/g, channel);
		url = url.replace(/__INSTALLS__/g, numdownloads);
		url = url.replace(/__LANG__/g, lang);
		url = url.replace(/__INTL__/g, lang);
		url = url.replace(/__URL__/g, "http://us.yimg.com/i/sh/bl.gif");
		if(url.charAt(0) == "/"){
			url = server + url;
		}
		else{
			url = server +"/"+ url;
		}
		url = "http://"+ url;
		var iosvc = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var channel = iosvc.newChannel(url, 0, null);
		var listenter = {
			onStartRequest: function(request, context){ },
			onDataAvailable: function(request, context, inputStream, offset, count){ },
			onStopRequest: function(request, context, statusCode){
				request = request.QueryInterface(Components.interfaces.nsIHttpChannel);
				if(request.responseStatus >= 400) {
				}
				else{
				}
			}
		}
		channel.asyncOpen(listenter, null);
	}catch(e){
	}
}
