/*
 * Copyright 2005 - 2006 Yahoo! Inc. All rights reserved.
 */
function yahooButtonHandler(event) {
	try{
		event.preventBubble();
		var btn = event.target;
		if(btn.tagName == "menupopup"){
			btn = btn.parentNode;
		}
		var handler = {
			cmd		: parseInt(btn.getAttribute("yfunc")),
			track 	: btn.getAttribute("ytrack"),
			url 	: btn.getAttribute("yurl").split(","),
			id		: "",
			raw 	: btn.getAttribute("yevent").split(",")
		}
		if(!btn.hasAttribute("yfunc")){
			handler.cmd = handler.raw[1] || 0;
		}
		if(!btn.hasAttribute("ytrack") && handler.raw[2] != null){
			handler.track = handler.raw[2];
		}
		if(!btn.hasAttribute("yurl") && handler.raw[3] != null){
			var url = handler.raw;
			url.splice(0,3);
			handler.url = url;
		}
		var hash;
		try{
			eval("hash = {"+ btn.getAttribute("yhash") +"}");
			if(hash.id){
				handler.id = hash.id;
			}
		} catch(e){ }
		yahooNewFeedEventHandler(btn, handler, event);
		var menu = btn;
		while(menu.parentNode.tagName == "menupopup"){
			menu.parentNode.hidePopup();
			menu = menu.parentNode.parentNode;
		}
		var moreMenu = document.getElementById('yahoo-toolbar-more-menu');
		if(moreMenu != null){
			moreMenu.open = false;
		}
		if(btn.parentNode.id == "yahoo-toolbar-context" && yahooContextTarget != null){
			btn = yahooContextTarget;
		}
		var remove = null;
		while(btn != null && btn.id != "yahoo-toolbar" && btn.id != "yahoo-menubar-item"){
			if(btn.getAttribute && btn.getAttribute("ystyles").indexOf("REMOVEONCLICK") > -1){
				remove = btn;
				break;
			}
			else{
				btn = btn.parentNode;
			}
		}
		if(remove != null){
			if(remove.id != ""){
				yahooObsSvc.notifyObservers(null, "yahoo-btn-remove", remove.id);
				yahooToolbarFeed.domBuilder.remove(remove.id);
			}
			else{
				remove.parentNode.removeChild(remove);
			}
		}	
	}catch(e){
	}
}
function yahooNewFeedEventHandler(node, func, event) {
	try{
		if(event.type == 'click') {
			while(node.parentNode.tagName == 'menupopup') {
				node.parentNode.parentNode.setAttribute('open', false);
				node = node.parentNode.parentNode;
			}
		}
		try{
			var tracking = (func.cmd != 4) ? "" : func.track;
			if(tracking == "" || tracking == "-1"){
				tracking = func.id;
			}
			if(tracking != ""){
				yahooHitTrackingUrl(yahooGetFeedVariable("RDURI"), tracking);
			}
		} catch(e) { 
		}
		if(func.cmd == -1 && func.url.length == 1) {
			window.top._content.document.location = func.url;
			return true;
		} 
		else {
			switch(func.cmd) {
				case 0:
					return true;
					break;
				case 1:
					yahooAddBookmark(func, event.target);
					break;
				case 2:
					return false;
					break;
				case 3:
					yahooToggleButtons(func.raw);
					break;
				case 4:
					yahooLoadPage(func, event);
					break;
				case 5:
					return false;
					break;
				case 6:
					yahooRefreshToolbar();
					break;
				case 7:
					yahooAboutDialog();
					break;
				case 8:
					yahooUninstallToolbar();
					break;
				case 9:
					yahooRefreshToolbar(func.track);
					break;
				case 10:
					break;
				case 11:
					break;
				case 12:
					break;
				case 13:
					return false;
				case 14:
					yahooLoadPageIgnore(func);
					break;
				case 15:
					break;
				case 16:
					break;
				case 17:
					break;
				case 18:
					break;
				case 19:
					yahooFindHighlightToggle();
					break;
				case 20:
					yahooFindHighlightOff();
					break;
				case 21:
					yahooFindHighlightOn();
					break;
				case 22:
					return false;
					break;
				case 23:
					yahooFindHighlightOff();
					break;
				case 24:
					break;
				case 25:
					break;
				case 26:
					break;
				case 27:
					break;
				case 28:
					break;
				case 29:
					yahooReloadToolbarCached();
					break;
				case 30:
					break;
				case 31:
					break;
				case 32:
					break;
				case 33:
					break;
				case 34:
					break;
				case 35:
					yahooToggleButtonState(func);
					break;
				case 36:
					break;
				case 37:
					break;
				case 38:
					break;
				case 39:
					yahooClearSearchHistory();
					break;
				case 40:
					break;
				case 41:
					yahooAddToSearchHistory(func);
					break;
				case 42:
					yahooRunAntiSpy(func);
					break;
				case 45:
					yahooOpenOptions();
					break;
				case 47:
					yahooSaveMyWeb(func);
					break;
				case 48:
					yahooImportBookmarksHTML();
					break;
				case 49:
					var iconsonly = (yahooGetPref("yahoo.options.iconsonly") == true);
					yahooSetPref("yahoo.options.iconsonly", !iconsonly);
					break;
				case 51:
					yahooToggleAddToMy(func, event);
					break;
				case 66:
					yahooContextOpenUrl("current");
					break;
				case 67:
					yahooContextOpenUrl("tab");
					break;
				case 68:
					yahooRemoveMenuBarItem();
					break;
				case 69:
					yahooContextOpenUrl("window");
					break;
				default:
					break;
			}
		}
	} catch(e) {
	}
	return true;
}
function yahooAddBookmark(func, menuitem) {
	try{
		var loc = window.top._content.document.location;
		var url = "http://e.my.yahoo.com/config/edit_bookmark?";
		var host, title = "", args = "", location = "";
		var folder = (func.raw[2] || 1);
		args += ".server=&.done=&.src=bookmarks&.partner=&.orig_url=&.item_id=&.bmprop=&.action=ab&.display=&.save=Save";
		args += "&.folder="+ folder;
		location = yahooBuildEventURL(["$GETURL"]);
		title = yahooBuildEventURL(["$GETTITLE"], null, ["", "1"]);
		location = location.substring(7);
		title = title.substring(7);
		if((host = location.match(/^([a-z]*\%3A(\%2F){0,})(.*)$/i)) != null && host.length > 2){
			args = ".protocol="+ host[1] +"&.url="+ host[3] +"&"+ args;
		}
		args += "&.name="+ title;
		var req = new XMLHttpRequest();
		req.url = url;
		req.title = unescape(title);
		req.loc = unescape(location);
		req.folder = folder;
		req.bookmarkMenu = document.getElementById("yahoo-toolbar-bookmarks-"+ folder);
		req.onload = function (event) {
			try {
				if(this.bookmarkMenu == null){
					return;
				}
				this.bookmarkMenu = this.bookmarkMenu.firstChild;
				var inList = 0;
				var inserted = 0;
				for(var i = 0; i < this.bookmarkMenu.childNodes.length; i++) {
					if(this.bookmarkMenu.childNodes[i].tagName == "menuseparator"){
						inList = 1;
						if(i == this.bookmarkMenu.childNodes.length - 1) {
							yahooInsertBookmark(this.title, this.loc, -1, this.folder);
							break;
						}
					} 
					else if(inList == 1) {
						if(this.bookmarkMenu.childNodes[i].getAttribute('yurl') == this.loc) {
							this.bookmarkMenu.removeChild(this.bookmarkMenu.childNodes[i]);
							i--;
						}
						if(inserted == 0) {
							if(i == this.bookmarkMenu.childNodes.length - 1) {
								yahooInsertBookmark(this.title, this.loc, -1, this.folder);
								inserted = 1;
								i++;
							}
							else if(this.bookmarkMenu.childNodes[i].getAttribute('label').toLowerCase() <= this.title.toLowerCase() 
									&& this.bookmarkMenu.childNodes[i+1].getAttribute('label').toLowerCase() > this.title.toLowerCase()) {
								yahooInsertBookmark(this.title, this.loc, i+1, this.folder);
								inserted = 1;
								i++;
							}
						}
					}
				}
			} catch(e) {
			}
		}
		req.open("GET", url + args, true);
		req.send(null);
		return true;
	} catch(e){
	}
}
function yahooInsertBookmark(title, url, pos, folder) {
	try{
		var menus = new Array();
		menus[0] = document.getElementById("yahoo-toolbar-bookmarks-"+ folder);
		menus[1] = document.getElementById("menu_yahoo-toolbar-bookmarks-"+ folder);
		for(var i = 0; i < menus.length; i++){
			var menu = menus[i];
			if(menu == null){
				continue;
			}
			menu = menu.firstChild;
			var menuitem = window.top.document.createElement('menuitem');
			if(pos > 0) {
				menu.insertBefore(menuitem, menu.childNodes[pos]);
			} else {
				menu.appendChild(menuitem);
			}
			menuitem.setAttribute("label", title);
			menuitem.setAttribute("oncommand", "yahooButtonHandler(event)");
			menuitem.setAttribute("onclick", "if(event.button == 1) { yahooButtonHandler(event) }");
			menuitem.setAttribute("yevent", ",4,boo,%"+ url);
			menuitem.setAttribute("ytrack", "boo");
			menuitem.setAttribute("yfunc",  "4");
			menuitem.setAttribute('yurl', url);
		}
	} catch(e){
	}
}
function yahooToggleButtons(func) {
	for(var i = 2; i < func.raw.length; i++) {
		var node = window.top.document.getElementById('yahoo-toolbar-'+func.raw[i]);
		if(node != null) {
			if(node.style.display == 'none') {
				node.style.display = null;
			} else {
				node.style.display = 'none';
			}
		}
	}
	return true;
}
function yahooLoadPage(func, event) {
	var btn = event.target;
	var url = yahooBuildEventURL(func.url, event, func.raw);
	var openin = "current";
	if((event.button && event.button == 1) || (event.ctrlKey || event.altKey || event.metaKey)) {
		openin = "tab";
	}
	else if(btn && btn.getAttribute("ystyles").indexOf("EX_NEWWINDOWTAB") > -1){
		var ext = yahooGetPref("browser.link.open_external");
		switch(ext){
			case 1:
				openin = "current";
			break;
			case 2: 
				openin = "window";
			break
			case 3:
				openin = "tabtop";
			break;
		}
	}
	if(openin == "tab" || openin == "tabtop") {
		var tab = gBrowser.addTab(url);
		if(yahooGetPref('browser.tabs.loadInBackground') == false || openin == "tabtop") {
			gBrowser.selectedTab = tab;
			gBrowser.focus();
		}
	}
	else if(openin == "current"){
		gBrowser.loadURI(url);
	}
	else {
		gBrowser.contentWindow.open(url);
	}
	return true;
}
function yahooGetFeedVariable(name) {
	name = name.toLowerCase();
	var value = null;
	try{
		if(yahooToolbarFeed.values != null){
			value = yahooToolbarFeed.values.getString(name);
		}
		if(value == null){
			if(name.slice(-3) == "esc"){
				name = name.substring(0, name.length - 3);
				value = escape(yahooToolbarFeed.values.getString(name));
			}
			else if(name == "m_psrv"){
				var countryCode = yahooGetPref('yahoo.installer.country');
				value = yahooFeedHost;
				if(countryCode) {
					value = countryCode +'.'+ value;
				} 
			}
			else if(name.substring(0, 4) == "reg_"){
				if(name.length > 4) {
					value = yahooGetPref('yahoo.installer.'+ name.substring(4));
				}
			}
		}
	} catch(e){
	}
	return value;
}
function yahooBuildEventURL(funcUrl, event, rawFunc) {
	try{
		var url1 = null; 
		var url = "";
		var selection = "";
		var doc = document;
		var win = document.commandDispatcher.focusedWindow;
		if(window.top._content){
			var doc = window.top._content.document;	
		}
		if(win){
			selection = win.getSelection.call(win).toString();
		}
		var evntTrgt = document.popupNode;
		var evntTrgtLetter = (selection != "") ? "t" : "p";
		if(evntTrgt && evntTrgt.nodeName.toLowerCase() != "img"){
			var elem = evntTrgt;
			evntTrgt = null;
			while(elem){
				if(elem.nodeType == Node.ELEMENT_NODE
						&& (elem instanceof HTMLAnchorElement || elem instanceof HTMLAreaElement)
						&& elem.href){
					evntTrgt = elem;
					evntTrgtLetter = "a"
				}
				elem = elem.parentNode;
			}
		}
		else{
			evntTrgtLetter = "i";
		}
		var btn = null;
		var t_name = "";
		if(url.indexOf("%t") > -1 && event != null && (btn = yahooToolbarFeed.getNodeById(event.target.id)) != null && btn.hash != null){
			t_name = btn.hash.getString("trgt_"+ evntTrgtLetter) || "";
		}
		for(var i = 0; i < funcUrl.length; i++) {
			if(funcUrl[i].slice(0,1) == '%') {
				funcUrl[i] = funcUrl[i].slice(1);
				funcUrl[i] = funcUrl[i].replace(/%t/, t_name);
				url += funcUrl[i];
			} 
			else if(funcUrl[i].slice(0,1) == '$') {
				var varname = funcUrl[i];
				var feedVar = yahooGetFeedVariable(varname.slice(1));
				if(feedVar != null) {
					url += feedVar;
				} 
				else {
					try {
						funcUrl[i] = "";
						switch(varname){
							case "$BRWSEL":
								if(selection != ""){
									url1 = url;
									url = "";
								}
							break;
							case "$GETTITLE":
								if(evntTrgt && evntTrgt.hasAttribute("alt") && evntTrgt.alt.search(/[^\s]/) > -1){
									funcUrl[i] = evntTrgt.alt;
								}
								else if(evntTrgt && evntTrgt.nodeName.toLowerCase() == "img"){
									funcUrl[i] = evntTrgt.src.replace(/^.*?([^\/]*\.[^\/]*)$/, "$1"); 
								}
								else if(evntTrgt && evntTrgt.nodeName.toLowerCase() == "a"){
									funcUrl[i] = evntTrgt.innerHTML.replace(/<\/?[^>]+>/g, ''); 
									funcUrl[i] = funcUrl[i].replace(/[\s\n\t]/g, " "); 
								}
								else{
									funcUrl[i] = doc.title;
								}
								funcUrl[i] = encodeURIComponent(funcUrl[i]);
							break;
							case "$GETURL": 
							case "$PROTOCOL": 
							case "$GETPATH": 
								if(evntTrgt && evntTrgt.src){
									funcUrl[i] = evntTrgt.src;
								}
								else if(evntTrgt && evntTrgt.href){
									funcUrl[i] = evntTrgt.href;
								}
								else{
									funcUrl[i] = doc.location.href;
								}
								var u;
								if(varname != "$GETURL" && (u = funcUrl[i].match(/^([a-z]*:\/{0,})(.*)$/i)) != null){
									if(varname != "$PROTOCOL" && u.length > 1){
										funcUrl[i] = u[2];
									}
									else if(varname != "$GETPATH" && u.length > 2){
										funcUrl[i] = u[1];
									}
								}
								funcUrl[i] = encodeURIComponent(funcUrl[i]);
							break;
							break;
							case "$DONE": 
								funcUrl[i] = doc.location;
								funcUrl[i] = encodeURIComponent(funcUrl[i]);
							break;
							case "$DOMAIN": 
								funcUrl[i] = doc.location.hostname;
							break;
							case "$GETCSET": 
								funcUrl[i] = doc.characterSet;
							break;
							case "$GETPMTYPE":
								funcUrl[i] = doc.contentType;
							break;
							case "$VERSION": 
								funcUrl[i] = yahooGetPref('yahoo.installer.version.simple').replace(/\./g, '_').replace(/[^0-9_]/g, '');
							break;
							case "$OS": 
								funcUrl[i] = navigator.platform;
							break;
							case "$GETPLENGTH": 
								if(doc.documentElement.innerHTML) {
									funcUrl[i] = variable.replace(/\$GETPLENGTH/, doc.documentElement.innerHTML.length);
								}
							break;	
						}
					} catch(e) {
					}
					if(typeof(funcUrl[i]) == "string"){
						funcUrl[i] = funcUrl[i].replace(/\?/g, '%3F');
						funcUrl[i] = funcUrl[i].replace(/&/g, '%26');
						funcUrl[i] = funcUrl[i].replace(/=/g, '%3D');
						url += funcUrl[i];
					}
				}
			} 
			else {
				var element = window.top.document.getElementById('yahooToolbar'+ funcUrl[i]);
				if(element == null){
					url += funcUrl[i];
					url = url.replace(/%t/, t_name);
					continue;
				}
				var value = element.value;
				yahooUnicodeConverter.charset = 'utf-8';
				value = yahooUnicodeConverter.ConvertFromUnicode(value);
				value = escape(value);
				value = value.replace(/\+/g, "%2B");
				url += value;
				url += '&ei=UTF-8';
			}
		}
		if(url1 != null){
			if(url1.indexOf("mailto:") == 0){
				url = url1 +"'"+ encodeURIComponent(selection) +"'"+ url;
			}
			else if(url1.indexOf("ymsgr:") == 0){
				var len = 500 - (url1.length + url.length);
				if(len > 0){
					selection = encodeURIComponent(selection);
					if(selection.length > len){
						selection = selection.substring(0, len);
						var last = selection.length - 1;
						if((len = selection.lastIndexOf("%20")) > 0){
							selection = selection.substring(0, len);
						}
						else if(selection[last] == "%"){
							selection = selection.substring(0, last);
						}
						else if(isFinite(selection[last]) && selection[last - 1] == "%"){
							selection = selection.substring(0, last - 1);
						}
					}
					url = url1 +"'"+ selection +"'"+ url;
				}
				else{
					url = url1 + url;
				}
			}
			else{
				url = url1 + encodeURIComponent(selection) + url;
			}
		}
		if(url.match(new RegExp("^[a-z]+:"))) {
			return url;
		} 
		else {
			return 'http://'+url;
		}
	} catch(e){
	}
}
function yahooAboutDialog() {
	window.openDialog("chrome://ytoolbar/content/dialog.xul#about", "yahoo-about", "chrome, dialog, centerscreen");
	return true;
}
function yahooUninstallToolbar() {
	yahooUninstall();
	return true;
}
function yahooLoadPageIgnore(func) {
	yahooHitTrackingUrl(yahooGetFeedVariable("RDURI"), func.track);
	var url = yahooBuildEventURL(func.url);
	var req = new XMLHttpRequest();
	req.url = url;
	req.onload = function (event) {
		setTimeout('yahooRefreshToolbar();', 500);
		yahooFeedFunctionRequestObjects[this.id] = null;
	};
	req.open("GET", url, true);
	req.send(null);
	return true;
}
function yahooFindHighlightToggle() {
	var findHighlightState = yahooGetPref('yahoo.search.highlight');
	if(findHighlightState) {
		yahooSetPref('yahoo.search.highlight', false);
	} else {
		yahooSetPref('yahoo.search.highlight', true);
		var searchBox = window.top.document.getElementById('yahooEditBox');
		if(searchBox) {
		}
	}
	return true;
}
function yahooFindHighlightOff() {
	yahooSetPref('yahoo.search.highlight', false);
	return true;
}
function yahooFindHighlightOn() {
	yahooSetPref('yahoo.search.highlight', true);
	var searchBox = window.top.document.getElementById('yahooEditBox');
	if(searchBox) {
	}
	return true;
}
function yahooReloadToolbarCached() {
	yahooBuildToolbar();
}
function yahooToggleButtonState(func) {
	return yahooToggleButtons(func);
}
function yahooClearSearchHistory() {
	while(yahooSearchHistory.firstChild){
		yahooSearchHistory.removeChild(yahooSearchHistory.firstChild);
	}
	yahooSaveSearchHistory();
	yahooInitSearchBox();
	return true;
}
function yahooAddToSearchHistory(func) {
	return true;
}
function yahooRunAntiSpy(func) {
	var updateURL= func.raw[3];
	if(!Components.interfaces.nsIWindowsRegistry && !Components.interfaces.nsIWindowsShellService && !Components.interfaces.nsIWindowsRegKey){
		alert("Sorry, Anti-Spy is not supported on this version of Firefox at this time");
	}
	try {
		var path 	= yahooGetWinRegValue(3, "Software\\Yahoo\\ypsr\\paths", "base");
		var version	= yahooGetWinRegValue(3, "Software\\Yahoo\\ypsr", "Release Version") || "";
		var fv 		= yahooGetWinRegValue(3, "Software\\Yahoo\\ypsr", "fv") || "";
		var version = "" + fv;
		var exe = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		exe.initWithPath(path +"\\ypsr.exe")
		if(exe.exists() && version >= func.raw[4]) {
			exe.launch();
		} 
		else {
			window.open(updateURL) ;
		}
	} catch (e) {
		window.open(updateURL);
	}
	return true;
}
function yahooOpenOptions(){
	window.openDialog('chrome://ytoolbar/content/dialog.xul#option', 'YToolbarOptions', 'chrome, dialog, alwaysRaised, modal, centerscreen');
}
function yahooSaveMyWeb(func) {
	try{
		var firstElem = func.raw.shift();
		var funcID = func.raw.shift();
		var title = func.raw.shift();
		var width = func.raw.shift();
		var height = func.raw.shift();
		var maxSize = func.raw.shift();
		func.raw.shift();
		var url = yahooBuildEventURL(func.raw).split(/\?/);
		url[1] = unescape(url[1].replace(/%26/g, '%2526'));
		var args = yahooDecodeQueryString(url[1]);
		if(yahooMyWebDialog && yahooMyWebDialog.document) {
			yahooMyWebDialog.document.location = 'about:blank';
		} 
		else {
			var winargs = 'width='+ width +', height='+ height +',status=1,location=0,resizeable=1,scrollbars=1,left=100,top=50';
			yahooMyWebDialog = window.open('about:blank', 'myweb', winargs);
		}
		yahooMyWebDialog.document.title = title;
		var myForm = yahooMyWebDialog.document.createElement('form');
		myForm.setAttribute('method', 'POST');
		myForm.setAttribute('action', url[0]);
		yahooMyWebDialog.document.body.appendChild(myForm);
		for(var attr in args) {
			var input = yahooMyWebDialog.document.createElement('input');
			input.setAttribute('type', 'hidden');
			input.setAttribute('name', attr);
			if(attr == "ei"){
				input.setAttribute('value', 'utf-8');
			}
			else if(attr == "t" && document.characterSet){
				try{
					yahooUniConvert.charset = document.characterSet;
					args[attr] = yahooUniConvert.ConvertToUnicode(args[attr]);
				} catch(e){ }
				input.setAttribute('value', args[attr]);
			}
			else{
				input.setAttribute('value', args[attr].replace(/%26/g, '&').replace(/%3D/g, '='));
			}
			myForm.appendChild(input);
		}
		if(window._content.document.location.protocol == 'http:' && window._content.document.contentType.match(/^text\/.*/)) {
			var input = yahooMyWebDialog.document.createElement('input');
			input.setAttribute('type', 'hidden');
			input.setAttribute('name', 'arch');
			input.setAttribute('value', 1);
			myForm.appendChild(input);
			input = yahooMyWebDialog.document.createElement('textarea');
			input.setAttribute('name', 'c');
			input.setAttribute('style', 'visibility: hidden;');
			myForm.appendChild(input);
			var content;
			if(window._content.document.contentType == 'text/xml') {
				var doc = window._content.document;
				content = '<?xml';
				if(doc.xmlVersion) {
					content += ' version="'+ doc.xmlVersion +'"';
				}
				if(doc.xmlEncoding) {
					content += ' encoding="'+ doc.xmlEncoding +'"';
				}
				if(doc.xmlStandalone) {
					content += ' standalone="yes"';
				}
				content += '?>\n';
				for(var i = 0; i < doc.childNodes.length; i++) {
					content += yahooSerializeDOM(doc.childNodes[i]);
				}
			}
			else if(window._content.document.contentType == 'text/plain') {
				content = window._content.document.body.firstChild.firstChild.nodeValue;
			} 
			else {
				var doc = window._content.document;
				content = '<'+ doc.documentElement.nodeName;
				for(var i = 0; i < doc.documentElement.attributes.length; i++) {
					content += ' '+doc.documentElement.attributes[i].nodeName+'="'+doc.documentElement.attributes[i].nodeValue+'"';
				}
				content += '>';
				content += doc.documentElement.innerHTML;
				content += '</'+doc.documentElement.nodeName+'>';
			}
			if(maxSize) {
				input.innerHTML = content.substr(0, maxSize*1024);
			} else {
				input.innerHTML = content.innerHTML;
			}
		}
		myForm.submit();
		yahooMyWebDialog.QueryInterface(Components.interfaces.nsIDOMWindow).name = 'myweb';
	} catch(e){
	}
	return true;
}
function yahooSerializeDOM(node) {
	var xml = '';
	if(node.nodeType == node.ELEMENT_NODE) { 
		xml = '<'+node.nodeName;
		try {
			for(var i = 0; i < node.attributes.length; i++) {
				xml += ' '+node.attributes[i].nodeName+'="'+node.attributes[i].nodeValue.replace('"', '&quot;')+'"'; 
			}
		} catch(e) {
		}
		if(node.childNodes.length == 0) {
			xml += '/>';
		} else {
			xml += '>';
			for(var i = 0; i < node.childNodes.length; i++) {
				xml += yahooSerializeDOM(node.childNodes[i]);
			}
			xml += '</'+node.nodeName+'>';
		}
	} else if(node.nodeType == node.ATTRIBUTE_NODE) { 
		xml = ' '+node.nodeName+'="'+node.nodeValue+'"';
	} else if(node.nodeType == node.TEXT_NODE) { 
		xml = node.nodeValue;
	} else if(node.nodeType == node.CDATA_SECTION_NODE) { 
		xml = '<![CDATA['+node.data+']]>';
	} else if(node.nodeType == node.ENTITY_REFERENCE_NODE) { 
		xml = '';
	} else if(node.nodeType == node.ENTITY_NODE) { 
		xml = '';
	} else if(node.nodeType == node.PROCESSING_INSTRUCTION_NODE) { 
		xml = '<?'+node.nodeName+' '+node.data+'?>';
	} else if(node.nodeType == node.COMMENT_NODE) { 
		xml = '<!--'+node.nodeValue+'-->';
	} else if(node.nodeType == node.DOCUMENT_NODE) { 
		xml = '';
	} else if(node.nodeType == node.DOCUMENT_TYPE_NODE) { 
		xml = '<!DOCTYPE '+node.nodeName;
		if(node.publicId) {
			xml += ' PUBLIC "'+node.publicId+'" "'+node.systemId+'"';
		} else if(node.systemId) {
			xml += ' SYSTEM "'+node.systemId+'"';
		}
		if(node.internalSubset) {
			xml += ' ['+node.internalSubset+']';
		}
		xml += '>';
	} else if(node.nodeType == node.DOCUMENT_FRAGMENT_NODE) { 
		xml = '';
	} else if(node.nodeType == node.NOTATION_NODE) { 
		xml = '';
	}
	return xml;
}
function yahooImportBookmarksHTML() {
	var oBm = yahooGetProfileDir();
	oBm.appendRelativePath("bookmarks.html");
	var bookmarkData = yahooReadFile(oBm);
	if(bookmarkData == null){
		return;
	}
	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	converter.charset = 'utf-8';
	var bookmarkDataUC = converter.ConvertToUnicode(bookmarkData);
	if(yahooUnicodeConverter) {
		converter = yahooUnicodeConverter;
	} else {
		converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	}
	if(!converter.charset) {
		converter.charset = 'us-ascii';
	}
	bookmarkData = converter.ConvertFromUnicode(bookmarkDataUC);
	yahooWriteCacheFile('bookmarks.enc.html', bookmarkData);
	var boundary = '---------------------------';
	for(var i = 0; i < 20; i++) {
		boundary += Math.floor(Math.random() * 36);
	}
	var partnerCode = '';
	var formData = '\r\n--'+boundary+'\r\nContent-Disposition: form-data; name=".done"\r\n\r\nhttp%3a//my.yahoo.com/\r\n--'+boundary+'\r\nContent-Disposition: form-data; name=".src"\r\n\r\nbookmarks\r\n--'+boundary+'\r\nContent-Disposition: form-data; name=".partner"\r\n\r\n'+partnerCode+'\r\n--'+boundary+'\r\nContent-Disposition: form-data; name=".agent"\r\n\r\nns\r\n--'+boundary+'\r\nContent-Disposition: form-data; name="bookmarks"; filename="bookmarks.html"\r\nContent-Type: text/html\r\n\r\n'+bookmarkData+'\r\n--'+boundary+'\r\nContent-Disposition: form-data; name="Import"\r\n\r\nImport Bookmarks\r\n--'+boundary+'--';
	var req = new XMLHttpRequest();
	req.id = 'yahooImportBookmarks';
	req.open("POST", "http://e.my.yahoo.com/config/upload_bookmark", true);
	req.setRequestHeader("Content-type", "multipart/form-data; boundary="+boundary);
	req.setRequestHeader("Referer", "http://e.my.yahoo.com/config/upload_bookmark?.agent=ns&.src=bookmarks&.partner=&.done=http%3a//my.yahoo.com/");
	req.onload = function (event) {
		yahooFeedFunctionRequestObjects[this.id] = null;
		setTimeout("yahooRefreshToolbar();", 500);
	};
	yahooFeedFunctionRequestObjects[req.id] = req;
	req.send(formData);
	return true;
}
function yahooSetHomepageDialog() {
	var hp = yahooGetPref('browser.startup.homepage');
	window.openDialog('chrome://ytoolbar/content/dialog.xul#sethomepage', 'YToolbarSetHomepage', 'chrome, dialog, alwaysRaised, modal, centerscreen');
	var newhp = yahooGetPref('browser.startup.homepage');
	if(newhp != hp) {
		document.location = newhp;
	}
	return true;
}
function yahooToggleAddToMy(func, event) {
	rssAlert = 0;
	var pref = yahooGetPref('yahoo.addtomy');
	try {
		var item = event.target;
		var menu = event.target.parentNode.parentNode;
		if(menu.getAttribute('open') == 'true') {
			menu.setAttribute('open', 'false');
		}
		if(menu.parentNode.tagName != 'toolbar') {
			menu = menu.parentNode.parentNode;
			menu.setAttribute('open', 'false');
		}
	} catch(e) {
	}
	if(pref == true || pref == null){
		if(confirm(yahooGetString('ytoolbar.msg.my.add.disable'))) {
			yahooSetPref('yahoo.addtomy', false);
			pref = false;
			yahooCheckForRSS(null);
		} 
	}
	else {
		alert(yahooGetString('ytoolbar.msg.my.add.enable'));
		yahooSetPref('yahoo.addtomy', true);
		pref = true;
		yahooCheckForRSS(null);
	}
	var myMenus = [ document.getElementById('yahoo-toolbar-my-rssa'), document.getElementById('menu_yahoo-toolbar-my-rssa') ];
	for(var i = 0; i < myMenus.length; i++){
		if(myMenus[i] != null) {
			myMenus[i].setAttribute('checked', pref);
		}
	}
}
function yahooContextOpenUrl(type){
	var url = yahooContextTarget.getAttribute("yurl");
	url = url.split(",");
	url = yahooBuildEventURL(url);
	if(url == null || url == ""){
		return true;
	}
	if(type == "current" && gBrowser){ 
		gBrowser.loadURI(url);
	}
	else if(type == "tab" && gBrowser){ 
		var tab = gBrowser.addTab(url);
		if(yahooGetPref('browser.tabs.loadInBackground') == false) {
			browser.selectedTab = tab;
			browser.focus();
		}
	} 
	else{ 
		window.open(url);
	}
	return true;
}
function yahooRemoveMenuBarItem(){
	var menubar = document.getElementById('yahoo-menubar-item')
	yahooSetPref('yahoo.options.menubar', false);
	menubar.parentNode.setAttribute("open", false);
	menubar.parentNode.setAttribute("hidden", true);
}
