/*
 * Copyright 2005 - 2006 Yahoo! Inc. All rights reserved.
 */
function yahooUpdateSearchHistory(search, terms, event){
	try{
		var livesearch = yahooGetPref("yahoo.options.showlivesearch");
		var popup = document.getElementById("yahooToolbarEditBox-history");
		var yfunc = search.getAttribute("yfunc");
		var yevent = search.getAttribute("yevent");
		var gossip = search.getAttribute("ylive");
		if(event && (event.keyCode == event.DOM_VK_ENTER || event.keyCode == event.DOM_VK_RETURN) ) {
			yahooButtonHandler(event);
		}
		if(event && event.keyCode > 0){
			var ch = String.fromCharCode(event.keyCode);
			if(ch.search(/[\W]/) == 0 && event.keyCode != event.DOM_VK_BACK_SPACE && event.keyCode != event.DOM_VK_DELETE && event.keyCode != event.DOM_VK_CLEAR){
				return;
			}
		}
		if(livesearch == null)
			livesearch = true;
		if(livesearch && !terms && gossip && gossip != ""){
			if(yahooAutoSuggestChannel != null){
				yahooAutoSuggestChannel.cancel(404);
			}
			var url = gossip + escape(search.value);
			var iosvc = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			yahooAutoSuggestChannel = iosvc.newChannel(url, 0, null);
			var listenter = {
				data : "",
				stream : null,
				onStartRequest: function(request, context){ },
				onDataAvailable: function(request, context, inputStream, offset, count){ 
					if(this.stream == null){
						this.stream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
					}
					this.stream.init(inputStream);  
					this.data += this.stream.read(count);
				},
				onStopRequest: function(request, context, statusCode){
					request = request.QueryInterface(Components.interfaces.nsIHttpChannel);
					if(this.stream != null){
						this.stream.close();
					}
					if(request.responseStatus >= 400) {
						return;
					}
					else{
						var terms = [[],[]];
						try{
							var t = eval(this.data);
							if(typeof(t) == "object"){
								terms = t;
							}
						} catch(e){ }
						yahooUpdateSearchHistory(search, terms[1], event);
					}
				}
			}
			yahooAutoSuggestChannel.asyncOpen(listenter, null);
		}
		else if(popup){
			yahooAutoSuggestChannel = null;
			popup.clearSuggestions();
			if(terms && terms.length > 0){
				for(var i = 0; i < terms.length; i++){
					try{
						yahooUnicodeConverter.charset = 'utf-8';
						terms[i] = yahooUnicodeConverter.ConvertToUnicode(terms[i]);
					}catch(e){ }
				}
				popup.addSuggestionList(terms);
			}
			if(popup.getRowCount() > 0){
				popup.openPopup(search);
			}
		}
	} catch(e){
	}
}
function yahooBuildHistory() {
	try{
		var queries = yahooSearchHistory.childNodes;
		var search = document.getElementById("yahooToolbarEditBox");
		var history = document.getElementById("yahooToolbarEditBox-history");
		if(search != null){
			if(yahooGetPref('yahoo.toolbar.searchbox.width') != null){
				search.style.width = yahooGetPref('yahoo.toolbar.searchbox.width') +"px";
			}
			else{
				search.style.width = "200px";
			}
		}
		if(history != null){
			history.clearHistory();
			var menuitem, query, added = 0;
			for(var i = 0; i < queries.length; i++) {
				query = queries[i].childNodes[0].data;
				if(query.search(/[^\s]/) > -1){
					history.appendHistory(unescape(query));
					added++;
				}
				if(added >= 50){
					break;
				}
			}
		}
		yahooSetSearchboxSize();
	} catch(e){
	}
}
