/*
 * Copyright 2005 - 2006 Yahoo! Inc. All rights reserved.
 */
function yahooTurnOffDumbQuestions() {
	var hp = yahooGetPref('browser.startup.homepage');
	var dsearch = yahooGetPref('browser.search.defaulturl');
	var engine = yahooGetPref('browser.search.selectedEngine');
	var kwurl = yahooGetPref('keyword.URL');
	var vb = document.getElementById('yahoo-defaults');
	var regex = new RegExp("^https?://([^\/]*\.)?yahoo\.com/");
	if(hp.match(regex)) {
		var dvb = document.getElementById('yahoo-homepage');
		vb.removeChild(dvb);
	}
	if(engine == 'Yahoo' && dsearch.match(regex) && kwurl.match(regex)) {
		var dvb = document.getElementById('yahoo-search');
		vb.removeChild(dvb);
	}
	yahooSetPref('yahoo.homepage.dontask', true);
}
function yahooSetHomepage(url) {
	yahooSetPref('browser.startup.homepage', url);
}
function yahooSetDefaultSearchEngine(url) {
	var sc = yahooGetPref("yahoo.installer.sc") || "";
	url = url.replace(/fr=((ytff)|(slv5))\-[^&]*/g, "fr=ytff-"+ sc);
	var dirSvc = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
	var plugDir = dirSvc.get('SrchPlugns', Components.interfaces.nsILocalFile);
	var prefDir = dirSvc.get('PrefD', Components.interfaces.nsIFile);
	var engineFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	engineFile.initWithPath(plugDir.path);
	engineFile.appendRelativePath('yahoo.src');
	var imgFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	imgFile.initWithPath(plugDir.path);
	imgFile.appendRelativePath('yahoo.gif');
	var localStore = dirSvc.get('LclSt', Components.interfaces.nsILocalFile);
	var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
	var localDS = rdfService.GetDataSourceBlocking("file://"+localStore.path);
	localDS.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	var predicate = rdfService.GetResource('searchengine');
	var subject = rdfService.GetResource('chrome://browser/content/browser.xul#searchbar');
	var oldname = localDS.GetTarget(subject, predicate, true);
	var newname = rdfService.GetLiteral("engine://"+ escape(engineFile.path));
	if(oldname && oldname instanceof Components.interfaces.nsIRDFLiteral) {
		localDS.Change(subject, predicate, oldname, newname);
	} 
	else {
		localDS.Assert(subject, predicate, newname, true);
	}
	predicate = rdfService.GetResource('src');
	oldname = localDS.GetTarget(subject, predicate, true);
	newname = rdfService.GetLiteral('file:///'+escape(imgFile.path));
	if(oldname && oldname instanceof Components.interfaces.nsIRDFLiteral) {
		localDS.Change(subject, predicate, oldname, newname);
	} 
	else{
		localDS.Assert(subject, predicate, newname, true);
	}
	try {
		localDS.Flush();
		localDS.Refresh(true);
		predicate = rdfService.GetResource('searchengine');
		var storedname = localDS.GetTarget(subject, predicate, true);
		if(storedname instanceof Components.interfaces.nsIRDFLiteral) {
		} 
		else {
		}
	} catch(e) {
	}
	yahooSetPref('browser.search.defaultenginename', 'Yahoo');
	yahooSetPref('browser.search.defaulturl', url);
	yahooSetPref('browser.search.selectedEngine', 'Yahoo');
	var sc = yahooGetPref('yahoo.installer.sc');
	if(sc == null){
		sc = "";
	}
	yahooSetPref('keyword.URL', url);
	yahooHitTrackingUrl("/moz/__INTL__-as/*__URL__", null);
}
function yahooUpdateSettings() {
	try{
		if(yahooToolbarFeed == null){
			yahooToolbarFeed = Components.classes["@yahoo.com/feed/processor;1"].getService(Components.interfaces.nsIYahooFeedProcessor);
		}
		if(document.getElementById('yahoo-homepage') != null) {
			var rg = document.getElementById('yahoo-homepage').getElementsByTagName('radiogroup')[0];
			var rb = rg.getElementsByTagName('radio');
			for(var i = 0; i < rb.length; i++) {
				if(rb[i].selected == true && rb[i].getAttribute('value')) {
					yahooSetHomepage(rb[i].getAttribute('value'));
					var trackingId = yahooGetPref('yahoo.installer.country')+'-'+rb[i].getAttribute('id').replace(/^yahoo-/, '');
					yahooHitTrackingUrl("/moz/"+ trackingId +"/*__URL__", null);
					break;
				}
			}
		}
		if(document.getElementById('yahoo-search') != null) {
			var rg = document.getElementById('yahoo-search').getElementsByTagName('radiogroup')[0];
			var rb = rg.getElementsByTagName('radio');
			for(var i = 0; i < rb.length; i++) {
				if(rb[i].selected == true && rb[i].getAttribute('value')) {
					yahooSetDefaultSearchEngine(rb[i].getAttribute('value'));
					break;
				}
			}
		}
	} catch(e){
	}
}
